<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListesDemandesInfoCanal StructType
 * @subpackage Structs
 */
class ListesDemandesInfoCanal extends AbstractStructBase
{
    /**
     * The Destinataires
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var DestinataireDestinationAvecID[]
     */
    public $Destinataires;
    /**
     * Constructor method for ListesDemandesInfoCanal
     * @uses ListesDemandesInfoCanal::setDestinataires()
     * @param DestinataireDestinationAvecID[] $destinataires
     */
    public function __construct(array $destinataires = array())
    {
        $this
            ->setDestinataires($destinataires);
    }
    /**
     * Get Destinataires value
     * @return DestinataireDestinationAvecID[]|null
     */
    public function getDestinataires()
    {
        return $this->Destinataires;
    }
    /**
     * This method is responsible for validating the values passed to the setDestinataires method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDestinataires method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDestinatairesForArrayConstraintsFromSetDestinataires(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $listesDemandesInfoCanalDestinatairesItem) {
            // validation for constraint: itemType
            if (!is_string($listesDemandesInfoCanalDestinatairesItem)) {
                $invalidValues[] = is_object($listesDemandesInfoCanalDestinatairesItem) ? get_class($listesDemandesInfoCanalDestinatairesItem) : sprintf('%s(%s)', gettype($listesDemandesInfoCanalDestinatairesItem), var_export($listesDemandesInfoCanalDestinatairesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Destinataires property can only contain items of type DestinataireDestinationAvecID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Destinataires value
     * @throws \InvalidArgumentException
     * @param DestinataireDestinationAvecID[] $destinataires
     * @return \StructType\ListesDemandesInfoCanal
     */
    public function setDestinataires(array $destinataires = array())
    {
        // validation for constraint: array
        if ('' !== ($destinatairesArrayErrorMessage = self::validateDestinatairesForArrayConstraintsFromSetDestinataires($destinataires))) {
            throw new \InvalidArgumentException($destinatairesArrayErrorMessage, __LINE__);
        }
        $this->Destinataires = $destinataires;
        return $this;
    }
    /**
     * Add item to Destinataires value
     * @throws \InvalidArgumentException
     * @param DestinataireDestinationAvecID $item
     * @return \StructType\ListesDemandesInfoCanal
     */
    public function addToDestinataires(DestinataireDestinationAvecID $item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The Destinataires property can only contain items of type DestinataireDestinationAvecID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Destinataires[] = $item;
        return $this;
    }
}
